#!/bin/bash
  echo
  echo "__________________________________________________________"
  echo "     PCM to MP3 lame batch encoder shell script v. 1.0    "
  echo "__________________________________________________________"
  echo
SAVEIF=$IFS

IFS=$(echo -ne "\n\b")

declare used_exts='()'

a=$#

bitrate=${1:-160}
ext=${2:-aif}


if [ "$a" -lt "2" ]; then 
	echo "--- USAGE: "
	echo "     pcm2mp3 <bitrate> <src_fmt_ext1> [<src_fmt_ext2> ...]"
	echo "__________________________________________________________"
	echo
	IFS=$SAVEIFS
	exit 1
fi

if [ -n "$bitrate" ] && [ "$bitrate" -eq "$bitrate" ] 2>/dev/null; then
  echo "--- desired bitrate is" $bitrate "kbps"
else
  echo "--- bitrate must be an integer"
  IFS=$SAVEIFS
  exit 1
fi

if [ "$bitrate" -le "128" ]; then bitrate=128
	elif [ "$bitrate" -le "160" ]
	 then bitrate=160
    elif [ "$bitrate" -le "192" ]
     then bitrate=192
    elif [ "$bitrate" -le "256" ]
     then bitrate=265
    else 
     	bitrate=320
fi     

echo "--- available  bitrate is" $bitrate "kbps"

aiffcount=0
aifcount=0
wavcount=0
 
shift 1

for ext
	do
	ext="${ext##*.}"
	if ! [[ "$ext" =~ ^(aiff|aif|wav)$ ]]; then 
		echo "--- source file fmt " \"\.$ext\" "isn't supported"
		continue  
	elif [[ "$ext" =~ ^(aiff)$ ]]; then
		used_exts[0]="aiff"
   	elif [[ "$ext" =~ ^(aif)$ ]]; then	
   		used_exts[1]="aif"  
   	elif [[ "$ext" =~ ^(wav)$ ]]; then   				
   		used_exts[2]="wav" 	
	fi
   				   				  
	for i in *; do
   		if [ "${i}" != "${i%.${ext}}" ]; then
   			if [[ "$ext" =~ ^(aiff)$ ]]; then
   				((aiffcount++))
   			elif [[ "$ext" =~ ^(aif)$ ]]; then
   				((aifcount++))
   			elif [[ "$ext" =~ ^(wav)$ ]]; then   				
   				((wavcount++))				
   			fi
        	/usr/local/bin/lame -h -b "$bitrate" "$i" "${i%.*}.mp3"
        else
        	:
   	 	fi     
	done
done

if [ "${used_exts[0]}" == "aiff" ] && [ $aiffcount == "0" ]; then
	echo "--- no AIFF files found in $PWD"
fi 
if [ "${used_exts[1]}" == "aif" ] && [ $aifcount == "0" ]; then
	echo "--- no  AIF files found in $PWD"
fi 
if [ "${used_exts[2]}" == "wav" ] && [ $wavcount == "0" ]; then
	echo "--- no  WAV files found in $PWD"
fi 

k=0
ext1=mp3
for r in *; do
    if [ "${r}" != "${r%.${ext1}}" ]; then
    	mkdir -p mp3
    	k=1
    fi
done

if [ "$k" -ge 1 ]; then
	for i in *.mp3; do
		mv "$i" ./mp3
	done
fi

echo "__________________________________________________________"
echo
IFS=$SAVEIFS